; lispdoc.lsp                  Gordon S. Novak Jr.            ; 03 Jan 2000

; Copyright (c) 2007 The University of Texas at Austin.  All rights reserved.

; 19 Sep 95

; (car (do-external-symbols (x (symbol-package 'car)) (push x *lisp-symbols*)))
; (defun symbol-sort (x y) (string< (symbol-name x) (symbol-name y)))
; (setq *lisp-symbols* (sort *lisp-symbols* #'symbol-sort))

(defvar *lisp-fn-tree* nil)

(setq *lisp-fn-tree*
  '(z (+ + - * / /= 1+ 1- < <= = > >=)
      (a ABS ACONS ACOS ACOSH ADJOIN
	 ADJUST-ARRAY ADJUSTABLE-ARRAY-P AIX AIX3 AKCL ALLOCATE ALPHA-CHAR-P
	 ALPHANUMERICP AND APPEND APPLY APPLYHOOK APROPOS APROPOS-LIST
	 ("array..." AREF
	   ARRAY ARRAY-DIMENSION ARRAY-DIMENSION-LIMIT ARRAY-DIMENSIONS
	   ARRAY-ELEMENT-TYPE ARRAY-HAS-FILL-POINTER-P ARRAY-IN-BOUNDS-P
	   ARRAY-RANK ARRAY-RANK-LIMIT ARRAY-ROW-MAJOR-INDEX ARRAY-TOTAL-SIZE
	   ARRAY-TOTAL-SIZE-LIMIT ARRAYP)
	 ASH ASIN ASINH ASSERT ASSOC ASSOC-IF ASSOC-IF-NOT ATAN ATANH ATOM)
      (b BIGNUM
	 ("bit..." BIT BIT-AND BIT-ANDC1 BIT-ANDC2
	  BIT-EQV BIT-IOR BIT-NAND BIT-NOR BIT-NOT BIT-ORC1 BIT-ORC2
	  BIT-VECTOR BIT-VECTOR-P BIT-XOR)
	 BLOCK
	 ("boole..."  BOOLE BOOLE-1 BOOLE-2
	  BOOLE-AND BOOLE-ANDC1 BOOLE-ANDC2 BOOLE-C1 BOOLE-C2 BOOLE-CLR
	  BOOLE-EQV BOOLE-IOR BOOLE-NAND BOOLE-NOR BOOLE-ORC1 BOOLE-ORC2
	  BOOLE-SET BOOLE-XOR)
	 BOTH-CASE-P BOUNDP BREAK BUGGY-CC BUTLAST BY
	 BYE BYTE BYTE-POSITION BYTE-SIZE)
      (c ("car..." CAAAAR CAAADR CAAAR CAADAR CAADDR
	  CAADR CAAR CADAAR CADADR CADAR CADDAR CADDDR CADDR CADR
	  CAR CDAAAR CDAADR CDAAR CDADAR CDADDR CDADR CDAR CDDAAR CDDADR
	  CDDAR CDDDAR CDDDDR CDDDR CDDR CDR)
	 CALL-ARGUMENTS-LIMIT CASE CATCH CCASE CCLOSURE CEILING CERROR CFUN
	 ("char..." CHAR CHAR-BIT CHAR-BITS
	  CHAR-BITS-LIMIT CHAR-CODE CHAR-CODE-LIMIT CHAR-CONTROL-BIT
	  CHAR-DOWNCASE CHAR-EQUAL CHAR-FONT CHAR-FONT-LIMIT CHAR-GREATERP
	  CHAR-HYPER-BIT CHAR-INT CHAR-LESSP CHAR-META-BIT CHAR-NAME
	  CHAR-NOT-EQUAL CHAR-NOT-GREATERP CHAR-NOT-LESSP CHAR-SUPER-BIT
	  CHAR-UPCASE CHAR/= CHAR< CHAR<= CHAR= CHAR> CHAR>= CHARACTER
	  CHARACTERP)
	 CHECK-TYPE CIS CLEAR-INPUT CLEAR-OUTPUT CLINES CLOSE
	 CLRHASH CODE-CHAR COERCE COMMON COMMONP
	 ("compile..." COMPILATION-SPEED COMPILE
	  COMPILE-FILE COMPILED-FUNCTION COMPILED-FUNCTION-P COMPILER-LET)
	 COMPLEX COMPLEXP CONCATENATE COND CONJUGATE CONS CONSP CONSTANTP
	 ("copy..." COPY-ALIST COPY-LIST COPY-READTABLE COPY-SEQ COPY-SYMBOL
	  COPY-TREE)
	 COS COSH COUNT COUNT-IF COUNT-IF-NOT CTYPECASE)
      (d DECF DECLARATION
	 DECLARE DECODE-FLOAT DECODE-UNIVERSAL-TIME
	 ("def..." DEFCFUN DEFCONSTANT
	  DEFENTRY DEFINE-MODIFY-MACRO DEFINE-SETF-METHOD DEFLA DEFMACRO
	  DEFPARAMETER DEFSETF DEFSTRUCT DEFTYPE DEFUN DEFVAR)
	 ("delete..." DELETE
	  DELETE-DUPLICATES DELETE-FILE DELETE-IF DELETE-IF-NOT)
	 DENOMINATOR
	 DEPOSIT-FIELD DESCRIBE DIGIT-CHAR DIGIT-CHAR-P DIRECTORY
	 DIRECTORY-NAMESTRING DISASSEMBLE
	 ("do..." DO DO* DO-ALL-SYMBOLS DO-EXTERNAL-SYMBOLS DO-SYMBOLS)
	 DOCUMENTATION DOLIST DOTIMES
	 ("double..." DOUBLE DOUBLE-FLOAT DOUBLE-FLOAT-EPSILON
	  DOUBLE-FLOAT-NEGATIVE-EPSILON)
	 DPB DRIBBLE)
      (e ECASE ED EIGHTH ELT ENCODE-UNIVERSAL-TIME ENDP
	 ENOUGH-NAMESTRING EQ EQL EQUAL EQUALP ERROR ETYPECASE EVAL
	 EVAL-WHEN EVALHOOK EVENP EVERY EXP EXPORT EXPT)
      (f FAT-STRING FBOUNDP
	 FCEILING FFLOOR FIFTH
	 ("file..." FILE-AUTHOR FILE-LENGTH FILE-NAMESTRING
	  FILE-POSITION FILE-WRITE-DATE)
	 FILL FILL-POINTER
	 ("find..." FIND FIND-ALL-SYMBOLS FIND-IF FIND-IF-NOT FIND-PACKAGE
	  FIND-SYMBOL)
	 FINISH-OUTPUT FIRST FIXNUM FLET
	 ("float..." FLOAT FLOAT-DIGITS FLOAT-PRECISION
	 FLOAT-RADIX FLOAT-SIGN FLOATP)
	 FLOOR FMAKUNBOUND FORCE-OUTPUT FORMAT
	 FOURTH FRESH-LINE FROUND FTRUNCATE FTYPE FUNCALL FUNCTION FUNCTIONP)
      (g GBC GCD GCL GENSYM GENTEMP GET
	 ("get..." GET-DECODED-TIME
	  GET-DISPATCH-MACRO-CHARACTER GET-INTERNAL-REAL-TIME
	  GET-INTERNAL-RUN-TIME GET-MACRO-CHARACTER GET-OUTPUT-STREAM-STRING
	  GET-PROPERTIES GET-SETF-METHOD GET-SETF-METHOD-MULTIPLE-VALUE
	  GET-UNIVERSAL-TIME)
	 GETF GETHASH GFUN GO GRAPHIC-CHAR-P)
      (h HASH-TABLE HASH-TABLE-COUNT HASH-TABLE-P HELP HELP* HOST-NAMESTRING)
      (i IDENTITY IEEE-FLOATING-POINT IF IGNORE IMAGPART IMPORT IN-PACKAGE INCF
	 INLINE INPUT-STREAM-P INSPECT INT INT-CHAR INTEGER
	 INTEGER-DECODE-FLOAT INTEGER-LENGTH INTEGERP INTERN
	 INTERNAL-TIME-UNITS-PER-SECOND INTERSECTION ISQRT)
      (k KCL KEYWORD KEYWORDP KYOTO)
      (l LABELS
	 ("lambda..." LAMBDA LAMBDA-BLOCK LAMBDA-BLOCK-CLOSURE
	  LAMBDA-CLOSURE LAMBDA-LIST-KEYWORDS LAMBDA-PARAMETERS-LIMIT)
	 LAST LCM LDB LDB-TEST LDIFF
	 ("least..." LEAST-NEGATIVE-DOUBLE-FLOAT
	  LEAST-NEGATIVE-LONG-FLOAT LEAST-NEGATIVE-SHORT-FLOAT
	  LEAST-NEGATIVE-SINGLE-FLOAT LEAST-POSITIVE-DOUBLE-FLOAT
	  LEAST-POSITIVE-LONG-FLOAT LEAST-POSITIVE-SHORT-FLOAT
	  LEAST-POSITIVE-SINGLE-FLOAT)
	 LENGTH LET LET*
	 ("lisp..." LISP-IMPLEMENTATION-TYPE LISP-IMPLEMENTATION-VERSION)
	 LIST LIST* LIST-ALL-PACKAGES LIST-LENGTH LISTEN LISTP LOAD LOCALLY LOG
	 ("log..." LOGAND
	  LOGANDC1 LOGANDC2 LOGBITP LOGCOUNT LOGEQV LOGIOR LOGNAND LOGNOR
	  LOGNOT LOGORC1 LOGORC2 LOGTEST LOGXOR)
	 ("long..." LONG-FLOAT LONG-FLOAT-EPSILON
	  LONG-FLOAT-NEGATIVE-EPSILON LONG-SITE-NAME)
	 LOOP LOWER-CASE-P)
      (m ("machine..." MACHINE-INSTANCE MACHINE-TYPE MACHINE-VERSION)
	 ("macro..." MACRO MACRO-FUNCTION
	  MACROEXPAND MACROEXPAND-1 MACROLET)
	 ("make..." MAKE-ARRAY MAKE-BROADCAST-STREAM
	  MAKE-CHAR MAKE-CONCATENATED-STREAM MAKE-DISPATCH-MACRO-CHARACTER
	  MAKE-ECHO-STREAM MAKE-HASH-TABLE MAKE-LIST MAKE-PACKAGE
	  MAKE-PATHNAME MAKE-RANDOM-STATE MAKE-SEQUENCE MAKE-STRING
	  MAKE-STRING-INPUT-STREAM MAKE-STRING-OUTPUT-STREAM MAKE-SYMBOL
	  MAKE-SYNONYM-STREAM MAKE-TWO-WAY-STREAM)
	 MAKUNBOUND
	 ("map..." MAP MAPC MAPCAN
	  MAPCAR MAPCON MAPHASH MAPL MAPLIST)
	 MASK-FIELD MAX MEMBER MEMBER-IF
	 MEMBER-IF-NOT MERGE MERGE-PATHNAMES MIN MINUSP MISMATCH MOD
	 ("most..." MOST-NEGATIVE-DOUBLE-FLOAT MOST-NEGATIVE-FIXNUM
	  MOST-NEGATIVE-LONG-FLOAT MOST-NEGATIVE-SHORT-FLOAT
	  MOST-NEGATIVE-SINGLE-FLOAT MOST-POSITIVE-DOUBLE-FLOAT
	  MOST-POSITIVE-FIXNUM MOST-POSITIVE-LONG-FLOAT
	  MOST-POSITIVE-SHORT-FLOAT MOST-POSITIVE-SINGLE-FLOAT)
	 ("multiple..." MULTIPLE-VALUE-BIND MULTIPLE-VALUE-CALL
	  MULTIPLE-VALUE-LIST
	  MULTIPLE-VALUE-PROG1 MULTIPLE-VALUE-SETQ MULTIPLE-VALUES-LIMIT))
      (n NAME-CHAR NAMESTRING NBUTLAST NCONC NIL NINTERSECTION NINTH NOT
	 NOTANY NOTEVERY NOTINLINE NRECONC NREVERSE NSET-DIFFERENCE
	 NSET-EXCLUSIVE-OR NSTRING-CAPITALIZE NSTRING-DOWNCASE
	 NSTRING-UPCASE NSUBLIS NSUBST NSUBST-IF NSUBST-IF-NOT NSUBSTITUTE
	 NSUBSTITUTE-IF NSUBSTITUTE-IF-NOT NTH NTHCDR NULL NUMBER NUMBERP
	 NUMERATOR NUNION)
      (o OBJECT ODDP OPEN OPTIMIZE OR OTHERWISE OUTPUT-STREAM-P)
      (p ("package..." PACKAGE PACKAGE-NAME PACKAGE-NICKNAMES
	  PACKAGE-SHADOWING-SYMBOLS PACKAGE-USE-LIST PACKAGE-USED-BY-LIST
	  PACKAGEP)
	 PAIRLIS PARSE-INTEGER PARSE-NAMESTRING
	 ("pathname..." PATHNAME
	  PATHNAME-DEVICE PATHNAME-DIRECTORY PATHNAME-HOST PATHNAME-NAME
	  PATHNAME-TYPE PATHNAME-VERSION PATHNAMEP)
	 PEEK-CHAR PHASE PI PLUSP
	 POP POSITION POSITION-IF POSITION-IF-NOT
	 ("print..." PPRINT PRIN1 PRIN1-TO-STRING PRINC PRINC-TO-STRING PRINT)
	 PROBE-FILE PROCLAIM PROCLAMATION
	 ("prog..." PROG PROG* PROG1 PROG2 PROGN PROGV)
	 PROVIDE PSETF PSETQ PUSH PUSHNEW)
      (q QUOTE)
      (r RANDOM RANDOM-STATE RANDOM-STATE-P RASSOC
	 RASSOC-IF RASSOC-IF-NOT RATIO RATIONAL RATIONALIZE RATIONALP
	 ("read..." READ
	  READ-BYTE READ-CHAR READ-CHAR-NO-HANG READ-DELIMITED-LIST
	  READ-FROM-STRING READ-LINE READ-PRESERVING-WHITESPACE READTABLE
	  READTABLEP)
	 REALPART REDUCE REM REMF REMHASH
	 ("remove..." REMOVE
	  REMOVE-DUPLICATES REMOVE-IF REMOVE-IF-NOT REMPROP)
	 RENAME-FILE
	 RENAME-PACKAGE REPLACE REQUIRE REST RETURN RETURN-FROM REVAPPEND
	 REVERSE RIOS ROOM ROTATEF ROUND RPLACA RPLACD)
      (s SAFETY SATISFIES SAVE
	 SBIT SCALE-FLOAT SCHAR SEARCH SECOND SEQUENCE
	 ("set..." SET SET-CHAR-BIT
	  SET-DIFFERENCE SET-DISPATCH-MACRO-CHARACTER SET-EXCLUSIVE-OR
	  SET-MACRO-CHARACTER SET-SYNTAX-FROM-CHAR SETF SETQ)
	 SEVENTH SFUN
	 SHADOW SHADOWING-IMPORT SHIFTF
	 ("short..." SHORT-FLOAT SHORT-FLOAT-EPSILON
	  SHORT-FLOAT-NEGATIVE-EPSILON SHORT-SITE-NAME)
	 ("sign..." SIGNED-BYTE SIGNED-CHAR SIGNED-SHORT SIGNUM)
	 ("simple..." SIMPLE-ARRAY SIMPLE-BIT-VECTOR
	  SIMPLE-BIT-VECTOR-P SIMPLE-STRING SIMPLE-STRING-P SIMPLE-VECTOR
	  SIMPLE-VECTOR-P)
	 SIN
	 ("single..." SINGLE-FLOAT SINGLE-FLOAT-EPSILON
	  SINGLE-FLOAT-NEGATIVE-EPSILON)
	 SINH SIXTH SLEEP SOFTWARE-TYPE
	 SOFTWARE-VERSION SOME SORT SPACE SPECIAL SPECIAL-FORM-P SPEED SPICE
	 SQRT STABLE-SORT STANDARD-CHAR STANDARD-CHAR-P STEP
	 ("stream..." STREAM STREAM-ELEMENT-TYPE STREAMP)
	 ("string..." STRING STRING-CAPITALIZE STRING-CHAR
	  STRING-CHAR-P STRING-DOWNCASE STRING-EQUAL STRING-GREATERP
	  STRING-LEFT-TRIM STRING-LESSP STRING-NOT-EQUAL STRING-NOT-GREATERP
	  STRING-NOT-LESSP STRING-RIGHT-TRIM STRING-TRIM STRING-UPCASE
	  STRING/= STRING< STRING<= STRING= STRING> STRING>= STRINGP)
	 STRUCTURE SUBLIS SUBSEQ SUBSETP
	 ("subst..." SUBST SUBST-IF SUBST-IF-NOT
	  SUBSTITUTE SUBSTITUTE-IF SUBSTITUTE-IF-NOT)
	 SUBTYPEP SVREF SXHASH
	 ("symbol..." SYMBOL SYMBOL-FUNCTION SYMBOL-NAME SYMBOL-PACKAGE
	  SYMBOL-PLIST SYMBOL-VALUE SYMBOLP)
	 SYSTEM)
      (t TAG TAGBODY TAILP TAN TANH TENTH
	 TERPRI THE THIRD THROW TIME TRACE TREE-EQUAL TRUENAME TRUNCATE
	 TRUNCATE_USE_C TYPE TYPE-OF TYPECASE TYPEP)
      (u UNEXPORT UNINTERN UNION
	 UNIX UNLESS UNREAD-CHAR UNSIGNED-BYTE UNSIGNED-CHAR UNSIGNED-SHORT
	 UNTRACE UNUSE-PACKAGE UNWIND-PROTECT UPPER-CASE-P USE-FAST-LINKS
	 USE-PACKAGE USER-HOMEDIR-PATHNAME)
      (v VALUES VALUES-LIST VARIABLE
	 VECTOR VECTOR-POP VECTOR-PUSH VECTOR-PUSH-EXTEND VECTORP VOID)
      (w WARN WHEN WITH-INPUT-FROM-STRING WITH-OPEN-FILE WITH-OPEN-STREAM
	 WITH-OUTPUT-TO-STRING WRITE WRITE-BYTE WRITE-CHAR WRITE-LINE
	 WRITE-STRING WRITE-TO-STRING)
      (y Y-OR-N-P YES-OR-NO-P)
      (z ZEROP)
))
